%% Sorts 
attr: sort. 
prin: sort. 
info: sort. 
role: sort. 
purpose: sort.
message: sort.
relation: sort.

%% Principals
str2prin: string -> prin.

%% Info
str2info: string -> info.

%% Message
str2msg: string -> message.
msg: info -> purpose -> message.
req: prin -> attr -> message.

%% relations
str2rel: string -> relation.
PCP: relation.
Payer: relation.
treatment-relation: relation.

%% Atributes
str2attr: string -> attr.
psychotherapy-notes: attr.
phi: attr.

%% Purposes
str2purp: string -> purpose.
referral: purpose.
consult: purpose.
prescription: purpose.
healthcare-op: prin -> purpose.
alert-of-crime-commission-location-victims-perpetrator: purpose.
counseling-training-programs: prin -> purpose.
defense-in-legal-proceeding: prin -> prin -> purpose.
disease-prevention-control: purpose.

%% Roles
str2role: string -> role.
covered-entity:role.
law-enforcement-official: role.
organized-healthcare-arrangement: role.
Health-care-provider: role.
public-health-authority: role.
foreign-gov-agency: role.

%%% Dates

%%% Add a relative time (int) to a date
plus: date -> int -> date EVAL.
lessthan: date(+) -> date(+) -> pred EVAL.

%% hasattr: info(+) -> attr(-) -> pred EVAL.
hasattrof: info(+) -> prin(-) -> attr(-) -> pred EVAL.
attr_in: attr(+) -> attr(+) -> pred EVAL.

inrole: prin(+) -> role(+) -> date(+) -> pred EVAL.

prompt: int. 
%% a time interval that is considered to be prompt
t_reasonable: int.

send: prin(-) -> prin(-) -> message(-) -> date(-) -> pred DB
%dbinfo "send" ("sender", "receiver", "message", "time").
%% send p1 p2 m t -- p1 sends p2 message m at time t.

inrelation: prin(+) -> prin(+) -> relation(-) -> date(-) -> pred DB
%dbinfo "inrelation" ("patient", "principal", "relation", "time").
%%inrelation p1 p2 r u -- p1 and p2 has relation r at time u

attr_in_db: attr(+) -> attr(+) -> date(+) -> pred DB
%dbinfo "attr_in_db" ("subattr", "supattr", "time").

hasattrof_db: info(+) -> prin(-) -> attr(-) -> date(-) -> pred DB
%dbinfo "hasattrof_db" ("info", "principal", "attribute", "time").

inrole_db: prin(+) -> role(+) -> date(-) -> pred DB
%dbinfo "inrole_db" ("principal", "role", "time").

purp_in_db: purpose(+) -> purpose(+) -> date(-) -> pred DB
%dbinfo "purp_in_db" ("subpurpose", "suppurpose", "time").

refers: prin(-) -> prin(-) -> prin(-) -> purpose(-) -> date(-) -> pred DB
%dbinfo "refers" ("source","recipient","patient","reason","time").
%%refers p1 p2 q referral t -- p1 refers q to p2 because of referral at time t

prescribes: prin(-) -> prin(-) -> purpose(-) -> date(-) -> pred DB
%dbinfo "prescribes" ("provider","patient","reason","time").
%%prescribes p2 q referral t -- p2 prescribes q because of prescription at time t

is-participant-of-organized-health: prin(+) -> prin(-) -> date(+) -> pred DB
%dbinfo "is_participant_of_organized_health" ("principal", "organizedhealth", "time").

directed-disclosure: prin(-) -> prin(-) -> prin(-) -> attr(-) -> purpose(-) -> date(-) -> pred DB
%dbinfo "directed_disclosure" ("director", "fromprincipal", "toprincipal", "attribute", "purpose" , "time").

purp_in: purpose(+) -> purpose(+) -> pred EVAL.
%% not_purp_in: purpose(+) -> purpose(+) -> pred SUBJ.

time_in: date(-) ->  date(+) -> date(+) -> pred EVAL. 
%% time_in u3 u1 u2 -- u1 < u3 <= u2
%% time_ge: date(-) -> date(+) -> pred EVAL.
eq_msg: message(+) -> message(-) -> pred EVAL.

is-valid-authorization: message(+) -> prin(+) -> prin(+) -> prin(+) -> date(+) -> pred SUBJ.
%% is-valid-authorization m p1 p2 p t pp --
%% m is a valid authorization of p1 disclosing to p2 p's record of attribute t for purpose pp

belongrole: prin(+) -> role (+) -> date(+) -> pred SUBJ.

providing-emergency-healthcare: prin(+) -> prin(+) -> date(+) -> pred SUBJ.
%% providing-emergency-healthcare p1 p -- p1 is providing emergency care to p

is-authorized-by-law: prin(+) -> purpose(+) -> date(+) -> pred SUBJ.
%%is-authorized-by-law p2 pp u -- p2 is authorized by law to collect or receive phi for purpose pp at time u

appears-necessary-to-alert-of-crime-commission-location-victims-perpetrator:
  prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.

%%% less frequently used predicates
beginrole: prin(-) -> role(-) -> date(-) -> pred DB
%dbinfo "beginrole" ("principal", "role", "time").

endrole: prin(+) -> role(+) -> date(-) -> pred DB
%dbinfo "endrole" ("principal", "role", "time").
